From 8bbe2b50cd7053496481f6fa03774e8725596363 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jan 21 2016 19:42:44 +0000
Subject: [PATCH 256/1001] Rename the fedmsgs widget to linechart.


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 56a93c1..90b18db 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -6,7 +6,7 @@ import hubs.models
 def add_user_widgets(session, hub, username, fullname):
     """ Some defaults for an individual user's hub. """
     widget = hubs.models.Widget(
-        plugin='fedmsgs', index=0, left=True,
+        plugin='linechart', index=0, left=True,
         _config=json.dumps({
             'username': username,
         }))
@@ -54,7 +54,7 @@ def add_user_widgets(session, hub, username, fullname):
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='pagure_pr', index=5, 
+        plugin='pagure_pr', index=5,
         _config=json.dumps({
             'repo': 'pagure',
         }))
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 2ff7e92..20f3ca1 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -4,7 +4,7 @@ from hubs.widgets import rules
 from hubs.widgets import sticky
 from hubs.widgets import about
 from hubs.widgets import badges
-from hubs.widgets import fedmsgs
+from hubs.widgets import linechart
 from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
 from hubs.widgets import subscriptions
@@ -24,7 +24,7 @@ registry = {
     'sticky': sticky,
     'about': about,
     'badges': badges,
-    'fedmsgs': fedmsgs,
+    'linechart': linechart,
     'fedmsgstats': fedmsgstats,
     'feed': feed,
     'subscriptions': subscriptions,
diff --git a/hubs/widgets/linechart.py b/hubs/widgets/linechart.py
new file mode 100644
index 0000000..0a3fb91
--- /dev/null
+++ b/hubs/widgets/linechart.py
@@ -0,0 +1,47 @@
+from hubs.hinting import hint
+from hubs.widgets.base import argument
+
+import jinja2
+
+import hubs.validators as validators
+
+import fedmsg.config
+config = fedmsg.config.load_config()
+
+
+template = jinja2.Template("""
+<div class="flex-container">
+
+    <img src="{{url}}" />
+
+</div>
+""")
+
+from hubs.widgets.chrome import panel
+chrome = panel("Weekly Activity")
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+    categories = ['git', 'Wiki', 'Copr', 'anitya', 'mirrormanager', 'ansible',
+                  'fedoratagger', 'Pkgdb', 'summershum', 'nuancier', 'Mailman',
+                  'fedbadges', 'FMN', 'koschei', 'compose', 'fedimg',
+                  'Jenkins', 'irc', 'FAS', 'buildsys', 'Askbot', 'pagure',
+                  'Bodhi', 'faf', 'kerneltest', 'github', 'Trac', 'meetbot',
+                  'planet', 'fedocal', 'hotness']
+    categories = [c.lower() for c in categories]
+    categories = "&".join(['category=%s' % c for c in categories ])
+    url = "https://apps.fedoraproject.org/datagrepper/charts/stackedline?delta=604800&N=12&style=clean&height=300&fill=true&user={username}&split_on=categories"
+    url = url + "&" + categories
+    url = url.format(username=username)
+    return dict(url=url)
+
+
+@hint(usernames=lambda widget: [widget.config['username']])
+def should_invalidate(message, session, widget):
+    usernames = fedmsg.meta.msg2usernames(message, **config)
+    username = widget.config['username']
+    return username in usernames

